//ܵƬԪɫ
precision mediump float;
varying vec2 vTextureCoord; //մӶɫĲ
uniform sampler2D sTexture;//
uniform float stK;
uniform float malphaValue;

uniform vec3 uLightLocation;//Դλ
uniform vec4 ulightAmbient;
uniform vec4 ulightDiffuse;
uniform vec4 ulightSpecular;

uniform mat4 uMMatrix; //任
uniform vec3 uCamera;	//λ

varying vec3 vPosition;//մӶɫĶλ
varying vec3 vNormal;//մӶɫݹķ

void pointLight(					//λռķ
  in vec3 normal,				//
  inout vec4 ambient,			//ǿ
  inout vec4 diffuse,				//ɢǿ
  inout vec4 specular,			//ǿ
  in vec3 lightLocation,			//Դλ
  in vec4 lightAmbient,			//ǿ
  in vec4 lightDiffuse,			//ɢǿ
  in vec4 lightSpecular			//ǿ
){
  ambient=lightAmbient;			//ֱӵóǿ  
  vec3 normalTarget=vPosition+normal;	//任ķ
  vec3 newNormal=(uMMatrix*vec4(normalTarget,1)).xyz-(uMMatrix*vec4(vPosition,1)).xyz;
  newNormal=normalize(newNormal); 	//Է
  //ӱ㵽
  vec3 eye= normalize(uCamera-(uMMatrix*vec4(vPosition,1)).xyz);  
  //ӱ㵽Դλõvp
  vec3 vp= normalize(lightLocation-(uMMatrix*vec4(vPosition,1)).xyz);  
  vp=normalize(vp);//ʽvp
  vec3 halfVector=normalize(vp+eye);	//ߵİ    
  float shininess=10.0;				//ֲڶȣԽСԽ⻬
  float nDotViewPosition=max(0.0,dot(newNormal,vp)); 	//vpĵ0ֵ
  diffuse=lightDiffuse*nDotViewPosition;				//ɢǿ
  float nDotViewHalfVector=dot(newNormal,halfVector);	//ĵ 
  float powerFactor=max(0.0,pow(nDotViewHalfVector,shininess)); 	//淴ǿ
  specular=lightSpecular*powerFactor;    			//㾵ǿ
}

void main()                         
{   
    //STƫ    
	vec2 st_Result=vec2(0,0);

	st_Result.x=vTextureCoord.x+stK;
	st_Result.y=vTextureCoord.y+stK;

   //ƬԪвɫֵ            
   vec4 finalColor = texture2D(sTexture, st_Result);
   
    vec4 ambient,diffuse,specular;    //ͨǿȵı 
   
   pointLight(normalize(vNormal),ambient,diffuse,specular,uLightLocation,//㶨λͨǿ 
   ulightAmbient,ulightDiffuse,ulightSpecular);  
   
   //ۺͨǿȼƬԪɫƬԪɫݸ
   gl_FragColor=finalColor*ambient + finalColor*diffuse + finalColor*specular;
   gl_FragColor.a*=malphaValue;
}